--- doxygen-1.4.1/src/memberdef.cpp.orig	Wed Jan  5 23:41:24 2005
+++ doxygen-1.4.1/src/memberdef.cpp	Tue Mar  8 20:19:20 2005
@@ -2108,14 +2108,16 @@
 
 bool MemberDef::isConstructor() const            
 { 
+  bool isD = (((QCString)m_defFileName).right(2)==".d");
   if (classDef) 
-     return name()==classDef->localName();
+     return isD ? name()=="this" : name()==classDef->localName();
   else
      return FALSE; 
 }
 
 bool MemberDef::isDestructor() const
 { 
+  if (((QCString)m_defFileName).right(2)==".d") return name()=="~this"; else
   return name().find('~')!=-1 && name().find("operator")==-1; 
 }
 
--- doxygen-1.4.1/src/classdef.cpp.orig	Mon Jan  3 20:17:52 2005
+++ doxygen-1.4.1/src/classdef.cpp	Tue Mar  8 20:49:16 2005
@@ -1984,10 +1984,11 @@
 {
   ClassDef *cd=md->getClassDef();
   if (cd->templateMaster()) cd=cd->templateMaster();
+  bool isD = (((QCString)cd->getDefFileName()).right(2)==".d");
   return md->name()=="operator=" || // assignment operator
-         md->name()==cd->localName() || // constructor
+         md->name()==cd->localName() || (isD && md->name()=="this") || // constructor
          (md->name().find('~')!=-1 && 
-          md->name().find("operator")==-1); // destructor
+          md->name().find("operator")==-1) || (isD && md->name()=="~this"); // destructor
 }
 
 /*! 
